
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
*
* Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*
* For more information, contact:
*
*  Generalitat Valenciana
*   Conselleria d'Infraestructures i Transport
*   Av. Blasco Ibez, 50
*   46010 VALENCIA
*   SPAIN
*
*      +34 963862235
*   gvsig@gva.es
*      www.gvsig.gva.es
*
*    or
*
*   IVER T.I. S.A
*   Salamanca 50
*   46005 Valencia
*   Spain
*
*   +34 963163400
*   dac@iver.es
*/
package es.gva.cit.catalogClient.schemas.discoverer;
import es.gva.cit.catalogClient.metadataXML.XMLNode;
import es.gva.cit.catalogClient.metadataXML.XMLTree;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Collection;
import javax.imageio.ImageIO;

/**
 * All classes that implement a tag-parser must to implement this
 * class. It only has some fields to show in the application form.
 * 
 * 
 * @author Jorge Piera Llodra (piera_jor@gva.es)
 */
public abstract class Record {
/**
 * 
 * 
 */
    private XMLNode node;

/**
 * 
 * 
 */
    private String title;

/**
 * 
 * 
 */
    private String abstract_;

/**
 * 
 * 
 */
    private String purpose;

/**
 * 
 * 
 */
    private String[] keyWords;
/**
 * 
 * 
 */
    private BufferedImage image;

/**
 * 
 * 
 */
    private String fileID;

/**
 * 
 * 
 */
    private URL serverURL;

/**
 * 
 * 
 */
    private Collection resources = new java.util.ArrayList();

/**
 * 
 * 
 * 
 * @return Returns the fileID.
 */
    public String getFileID() {        
        return fileID;
    } 
/**
 * <p></p>
 * 
 * 
 * 
 * @poseidon-type es.gva.cit.catalogClient.schemas.discoverer.Resource
 */
    public java.util.Collection resource = new java.util.ArrayList();

/**
 * 
 * 
 * 
 * @param fileID The fileID to set.
 */
    public void setFileID(String fileID) {        
        this.fileID = fileID;
    } 

/**
 * 
 * 
 * 
 * @return Returns the image.
 */
    public BufferedImage getImage() {        
        return image;
    } 

/**
 * 
 * 
 * 
 * @param image The image to set.
 */
    public void setImage(BufferedImage image) {        
        this.image = image;
    } 

/**
 * 
 * 
 * 
 * @return Returns the abstract_.
 */
    public String getAbstract_() {        
        return abstract_;
    } 

/**
 * 
 * 
 * 
 * @param abstract_ The abstract_ to set.
 */
    public void setAbstract_(String abstract_) {        
        this.abstract_ = abstract_;
    } 

/**
 * 
 * 
 * 
 * @return Returns the keyWords.
 */
    public String[] getKeyWords() {        
        return keyWords;
    } 

/**
 * 
 * 
 * 
 * @param keyWords The keyWords to set.
 */
    public void setKeyWords(String[] keyWords) {        
        this.keyWords = keyWords;
    } 

/**
 * 
 * 
 * 
 * @return Returns the purpose.
 */
    public String getPurpose() {        
        return purpose;
    } 

/**
 * 
 * 
 * 
 * @param purpose The purpose to set.
 */
    public void setPurpose(String purpose) {        
        this.purpose = purpose;
    } 

/**
 * 
 * 
 * 
 * @return Returns the title.
 */
    public String getTitle() {        
        return title;
    } 

/**
 * 
 * 
 * 
 * @param title The title to set.
 */
    public void setTitle(String title) {        
        this.title = title;
    } 

/**
 * 
 * 
 * 
 * @return Returns the node.
 */
    public XMLNode getNode() {        
        return node;
    } 

/**
 * 
 * 
 * 
 * @param node The node to set.
 */
    public void setNode(XMLNode node) {        
        this.node = node;
    } 

/**
 * 
 * 
 * 
 * @return Returns the resources.
 */
    public Resource[] getResources() {        
        Resource[] aux = new Resource[resources.size()];
        for (int i=0 ; i<aux.length ; i++){
            aux[i] = (Resource)resources.toArray()[i];
        }
        return aux;
    } 

/**
 * 
 * 
 * 
 * @param resources The resources to set.
 */
    public void setResources(Resource[] resources) {        
        this.resources = new java.util.ArrayList();
        if (resources == null){
        	return;
        }
        for (int i=0 ; i<resources.length ; i++){
            this.resources.add(resources[i]);
        }        
    } 

/**
 * 
 * 
 * 
 * @return Returns the serverURL.
 */
    public URL getServerURL() {        
        return serverURL;
    } 

/**
 * 
 * 
 * 
 * @param serverURL The serverURL to set.
 */
    public void setServerURL(URL serverURL) {        
        this.serverURL = serverURL;
    } 

/**
 * This method finds an image from an URL and returns it
 * 
 * 
 * @return 
 * @param label XML Label where the image link is.
 */
    protected BufferedImage getImageUrl(String label) {        
        BufferedImage img;
        XMLNode[] nodes = XMLTree.searchMultipleNode(getNode(), label);
        if ((nodes == null) || (nodes.length == 0)) {
            return null;
        }
        
        //Normal Procedure
        String imageURL = XMLTree.searchNodeValue(nodes[0], "bgFileName");
        img = getImage(imageURL);
        if (img != null)
            return img;
        
        //Deegree
        img = getImage(nodes[0].getText());
        if (img != null)
            return img;
                     
        //Is it Geonetwork running in port  8080?
        String sUrl = getGeonetworkImageUrl(imageURL,"8080");              
        img = getImage(sUrl);
        if (img != null)
            return img;
        
        //It is Geonetwork running in port 80?
        sUrl = getGeonetworkImageUrl(imageURL,"80");   
        img = getImage(sUrl);
        if (img != null)
            return img;
        
        
        img = getImage("http://delta.icc.es/wefex/images/" + nodes[0].getText() );
        if (img != null)
            return img;
        
        File fichero = new File("images/IcoRecord.png");
        try {
            return ImageIO.read(fichero);
        } catch (IOException e2) {
            // TODO Auto-generated catch block
            System.out.println("No he podido leer la imagen desde el fichero");
            return null;
        }    
    } 

/**
 * Only Used for Geonetwork
 * 
 * 
 * @return 
 * @param imageUrl Server URL
 * @param port Port to connect
 */
    private String getGeonetworkImageUrl(String imageUrl, String port) {        
        if (getServerURL() == null)
            return "";
        return "http://" + getServerURL().getHost() + ":" + port + "/geonetwork/srv/es/resources.getgraphover?" +
    	"id=" + getFileID() + "&" +
    	"fname=" + imageUrl;
    } 

/**
 * It gets an image from a URL
 * 
 * 
 * @return 
 * @param sUrl String with the image URL
 */
    protected BufferedImage getImage(String sUrl) {        
        try {
            URL Url = new URL(sUrl);
        
            return ImageIO.read(Url);
        } catch (MalformedURLException e) {
            // TODO Auto-generated catch block
            System.out.println("La URL de la imagen no es correcta: " + sUrl);
        } catch (IOException e1) {
            // TODO Auto-generated catch block
            System.out.println("No he podido leer la imagen desde la URL: " + sUrl);
        }
        return null;
    } 
 }
