/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.project.documents.layout.fframes;

/**
 * Interfaz para incluir mtodos necesarios para tener una dependencia con un
 * fframe.
 *
 * @author Vicente Caballero Navarro
 */
public interface IFFrameViewDependence {
    /**
     * Inserta una FFrame de la cual se necesita por tener una dependencia.
     *
     * @param f FFrame de la que se depende.
     */
    public void setFFrameDependence(IFFrame f);

    /**
     * Devuelve el FFrame utilizado.
     *
     * @return FFrame utilizado.
     */
    public IFFrame getFFrameDependence();

    /**
     * A partir de un Array con todas las FFrames se resuelve el FFrame del que
     * se tiene una dependencia.
     *
     * @param fframes Array de FFrames.
     */
    public void initDependence(IFFrame[] fframes);
   
}
