/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package es.gva.cit.gvsig.catalogClient.gui;

import java.awt.Frame;

import javax.swing.JDialog;

import org.gvsig.i18n.Messages;

import com.iver.andami.PluginServices;
import com.iver.andami.persistence.serverData.ServerDataPersistence;
import com.iver.andami.ui.mdiManager.IWindow;
import com.iver.andami.ui.mdiManager.WindowInfo;
import com.iver.utiles.swing.jcomboServer.ServerData;

import es.gva.cit.catalogClient.ui.serverConnect.ServerConnectDialogPanel;
import es.gva.cit.catalogClient.utils.Frames;

/**
 * Inicia la consulta de catlogo de metadatos
 *
 * @author luisw
 */
public class ConnectDialog extends ServerConnectDialogPanel implements IWindow {
	 public WindowInfo m_windowInfo = null;
	
	/**
     * Constructor de la ventana de dialogo.
     */
    public ConnectDialog() {
        super(null);
        init();
    }

    /**
     * Inicializa el Dialog
     */
    private void init() {
        this.setBounds(0, 0, 597, 238);
        setName("connectDialog");
    }

    /**
     * Add a server
     *
     * @param server
     */
    public static void addServer(ServerData server) {
        ServerConnectDialogPanel.addTreeMapServer(server);
    }

    /**
     * Search Button action
     */
    public void searchButtonActionPerformed() {
        addCurrentHost();
        closeJDialog();

        SearchDialog dialog = new SearchDialog(this,getClient());
        dialog.setCurrentServer(getCurrentServer());
        PluginServices.getMDIManager().addCentredWindow(dialog);
    }

    /**
     * Save the current host (if is neccessary) in a file using the andami
     * persistence
     */
    private void addCurrentHost() {
        String host = getClient().getSURL();
        ServerDataPersistence persistence = new ServerDataPersistence(this,ServerData.SERVER_TYPE_CATALOG);
        persistence.addServerData(new ServerData(host, ServerData.SERVER_TYPE_CATALOG, getClient().getProtocol(),controlsPanel.getDatabase()));
        persistence.setPersistent();
    }
    /**
     * 
     *
     */
    public void closeButtonActionPerformed() {   
       closeJDialog();
    }

    /**
     * Close the dialog
     */
    public void closeJDialog() {
        PluginServices.getMDIManager().closeWindow(ConnectDialog.this);
    }

    /* (non-Javadoc)
     * @see com.iver.andami.ui.mdiManager.View#getViewInfo()
     */
    public WindowInfo getWindowInfo() {
        if (m_windowInfo == null){
        	m_windowInfo = new WindowInfo(WindowInfo.MODALDIALOG);
        	m_windowInfo.setTitle(Messages.getText("metadata_catalog"));
        	m_windowInfo.setHeight(200);
        	m_windowInfo.setWidth(600);
        }
        return m_windowInfo;
    }
}
