/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package org.gvsig.rasterTools.saveRaster.ui.listener;


import java.awt.geom.Point2D;

import org.gvsig.rasterTools.saveRaster.tools.SaveRasterListenerImpl;
import org.gvsig.rasterTools.saveRaster.ui.main.SaveRasterControlsPanel;
import org.gvsig.rasterTools.saveRaster.ui.main.SaveRasterDefaultPanel;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.fmap.MapControl;
import com.iver.cit.gvsig.fmap.ViewPort;
import com.iver.cit.gvsig.fmap.layers.FLayers;
import com.iver.cit.gvsig.fmap.layers.FLyrRaster;
import com.iver.cit.gvsig.fmap.tools.Events.RectangleEvent;
import com.iver.cit.gvsig.project.documents.view.gui.View;


/**
 * Extensin de la clase SaveRasterListenerImpl de FMap para poder llamar a mtodos
 * de andami o de gvSIG.
 *
 * @author Nacho Brodin <brodin_ign@gva.es>
 */
public class SaveRasterListener extends SaveRasterListenerImpl {
	
	FLyrRaster 			layer = null;
	
	public SaveRasterListener(MapControl mapCtrl) {
		super(mapCtrl);
	}
		
	/**
	 * 
	 * @param flyr
	 */
	public void  setRasterLayer(FLyrRaster flyr){
		layer = flyr;
	}
	
	public void rectangle(RectangleEvent event) {
		super.rectangle(event);
				
		if (PluginServices.getMainFrame() != null)
		    PluginServices.getMainFrame().enableControls();
		
		FLayers layers = mapCtrl.getMapContext().getLayers();
		
		SaveRasterDefaultPanel saveRaster = new SaveRasterDefaultPanel(layers, mapCtrl);
		ViewPort vp = mapCtrl.getViewPort();
		Point2D ini = vp.fromMapPoint(rect.getMinX(), rect.getMinY());
		Point2D fin = vp.fromMapPoint(rect.getMaxX(), rect.getMaxY());
		if(Math.abs(fin.getY()-ini.getY())>10 && Math.abs(fin.getX()-ini.getX())>10){
			saveRaster.setProjection(((View) PluginServices.getMDIManager().getActiveWindow()).getProjection());
			
			SaveRasterControlsPanel dialog = (SaveRasterControlsPanel)saveRaster.getContentPanel();
			dialog.getBProperties().setEnabled(false);
			dialog.setProjection(vp.getProjection());
			dialog.setWidthInPixelsGeodesicas((int)Math.abs(fin.getX()-ini.getX()));
			dialog.setHeightInPixelsGeodesicas((int)Math.abs(fin.getY()-ini.getY()));
						
			int dec = 2;
			if(!vp.getProjection().isProjected())
				dec = 6;
						
			int indexPoint = String.valueOf(rect.getMaxX()).indexOf('.');
			try{
				dialog.getTInfDerX().setText(String.valueOf(rect.getMaxX()).substring(0,indexPoint + dec));
			}catch(IndexOutOfBoundsException ex){
				dialog.getTInfDerX().setText(String.valueOf(rect.getMaxX()));
			}
			
			indexPoint = String.valueOf(rect.getMaxY()).indexOf('.');
			try{
				dialog.getTInfDerY().setText(String.valueOf(rect.getMinY()).substring(0,indexPoint + dec));
			}catch(IndexOutOfBoundsException ex){
				dialog.getTInfDerY().setText(String.valueOf(rect.getMinY()));
			}
			
			indexPoint = String.valueOf(rect.getMinX()).indexOf('.');
			try{
				dialog.getTSupIzqX().setText(String.valueOf(rect.getMinX()).substring(0,indexPoint + dec));
			}catch(IndexOutOfBoundsException ex){
				dialog.getTSupIzqX().setText(String.valueOf(rect.getMinX()));
			}
			
			indexPoint = String.valueOf(rect.getMinY()).indexOf('.');
			try{
				dialog.getTSupIzqY().setText(String.valueOf(rect.getMaxY()).substring(0,indexPoint + dec));
			}catch(IndexOutOfBoundsException ex){
				dialog.getTSupIzqY().setText(String.valueOf(rect.getMaxY()));
			}
			
			PluginServices.getMDIManager().addWindow(saveRaster);
		}
	}
}
