package com.iver.cit.gvsig.fmap.edition.commands;

import java.io.IOException;

import com.iver.cit.gvsig.fmap.core.IRow;
import com.iver.cit.gvsig.fmap.drivers.DriverIOException;
import com.iver.cit.gvsig.fmap.edition.EditionEvent;
import com.iver.cit.gvsig.fmap.edition.IEditableSource;

/**
 * Aade una geometra nueva al EditableFeatureSource
 */
public class AddRowCommand extends AbstractCommand {
	private IRow row;
	private int calculatedIndex;
	private IEditableSource efs;
	private int sourceType=EditionEvent.GRAPHIC;

	public AddRowCommand(IEditableSource ef, IRow row, int calculatedIndex, int sourceType) {
		super();
		efs = ef;
		this.calculatedIndex = calculatedIndex;
		this.row = row;
		this.sourceType=sourceType;
	}

	/**
	 * @throws IOException
	 * @throws DriverIOException
	 * @see com.iver.cit.gvsig.fmap.edition.Command#undo()
	 */
	public void undo() throws DriverIOException, IOException {
		efs.undoAddRow(calculatedIndex, sourceType);
	}

	/**
	 * @throws IOException
	 * @throws DriverIOException
	 * @see com.iver.cit.gvsig.fmap.edition.Command#redo()
	 */
	public void redo() throws DriverIOException, IOException {
		calculatedIndex=efs.doAddRow(row, sourceType);
	}

	public String getType() {
		return "Add";
	}
}
