package com.iver.cit.gvsig.fmap.edition.writers.shp;

import java.io.File;
import java.io.IOException;

import org.cresques.cts.IProjection;

import com.hardcode.driverManager.DriverLoadException;
import com.hardcode.driverManager.DriverManager;
import com.hardcode.gdbms.engine.instruction.FieldNotFoundException;
import com.hardcode.gdbms.engine.values.Value;
import com.hardcode.gdbms.engine.values.ValueFactory;
import com.iver.cit.gvsig.fmap.DriverException;
import com.iver.cit.gvsig.fmap.core.DefaultFeature;
import com.iver.cit.gvsig.fmap.core.ShapeFactory;
import com.iver.cit.gvsig.fmap.crs.CRSFactory;
import com.iver.cit.gvsig.fmap.drivers.DriverIOException;
import com.iver.cit.gvsig.fmap.drivers.VectorialDriver;
import com.iver.cit.gvsig.fmap.drivers.VectorialFileDriver;
import com.iver.cit.gvsig.fmap.drivers.WithDefaultLegend;
import com.iver.cit.gvsig.fmap.edition.EditionEvent;
import com.iver.cit.gvsig.fmap.edition.EditionException;
import com.iver.cit.gvsig.fmap.edition.VectorialEditableAdapter;
import com.iver.cit.gvsig.fmap.layers.FLayer;
import com.iver.cit.gvsig.fmap.layers.FLyrVect;
import com.iver.cit.gvsig.fmap.layers.LayerFactory;
import com.iver.cit.gvsig.fmap.layers.VectorialFileAdapter;
import com.iver.cit.gvsig.fmap.rendering.LegendFactory;
import com.iver.cit.gvsig.fmap.rendering.VectorialLegend;


public class Prueba {

	public FLayer createLayer(String layerName, VectorialFileDriver d,
			File f, IProjection proj) throws DriverException {
		try {
			VectorialFileAdapter adapter = new VectorialFileAdapter(f);
			adapter.setDriver((VectorialDriver) d);
			VectorialEditableAdapter vea=new VectorialEditableAdapter();
			vea.setOriginalVectorialAdapter(adapter);
			//FileEditableFeatureSource fefs=new FileEditableFeatureSource((VectorialFileAdapter)adapter);
			//MemoryExpansionFile mef=new MemoryExpansionFile();
			//DefaultEditableFeatureSource defs=new DefaultEditableFeatureSource(mef,fefs, new FBitSet());

				//vea.start();





			FLyrVect capa = new FLyrVect();
			capa.setName(layerName);

			//TODO Meter esto dentro de la comprobacin de si hay memoria
			if (false) {
			} else {
				capa.setSource(adapter);
				capa.setProjection(proj);
			}

			try {
				// Le asignamos tambin una legenda por defecto acorde con
				// el tipo de shape que tenga. Tampoco s si es aqu el
				// sitio adecuado, pero en fin....
				if (d instanceof WithDefaultLegend) {
					WithDefaultLegend aux = (WithDefaultLegend) d;
					adapter.start();
					capa.setLegend((VectorialLegend) aux.getDefaultLegend());
					adapter.stop();
				} else {
					capa.setLegend(LegendFactory.createSingleSymbolLegend(
							capa.getShapeType()));
				}
			} catch (FieldNotFoundException e) {
				//Esta no puede saltar
			} catch (DriverIOException e) {
				throw new DriverException(e);
			}
			vea.startEdition(EditionEvent.GRAPHIC);
			try {
			Value[] values=new Value[5];
			values[0]=ValueFactory.createValue("hola0");
			values[1]=ValueFactory.createValue("hola1");
			values[2]=ValueFactory.createValue("hola2");
			values[3]=ValueFactory.createValue(300d);
			values[4]=ValueFactory.createValue(1d);
			DefaultFeature df0=new DefaultFeature(ShapeFactory.createPoint2D(1,3),values);
			vea.addRow(df0,"",EditionEvent.GRAPHIC);
			DefaultFeature df1=new DefaultFeature(ShapeFactory.createPoint2D(2,4),values);
			vea.addRow(df1,"",EditionEvent.GRAPHIC);
			DefaultFeature df2=new DefaultFeature(ShapeFactory.createPoint2D(3,5),values);
			vea.addRow(df2,"", EditionEvent.GRAPHIC);
			DefaultFeature df3=new DefaultFeature(ShapeFactory.createPoint2D(4,6),values);
			vea.addRow(df3,"", EditionEvent.GRAPHIC);
			} catch (DriverIOException e1) {
				e1.printStackTrace();
			} catch (IOException e1) {
				e1.printStackTrace();
			}
			try {
				ShpWriter writer=(ShpWriter)LayerFactory.getWM().getWriter("Shape Writer");
				writer.initialize(capa);
				vea.stopEdition(writer,EditionEvent.GRAPHIC);
			} catch (EditionException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		} catch (EditionException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
			return null;
		}
	public static void main(String[] args) {
		DriverManager driverManager = LayerFactory.getDM();
		driverManager.loadDrivers(new File("d:/eclipse/workspace/fwAndami/gvSIG/extensiones/com.iver.cit.gvsig/drivers"));
		Prueba prueba=new Prueba();
		FLayer layer=null;
		try {
			layer=prueba.createLayer("prueba", (VectorialFileDriver)LayerFactory.getDM().getDriver("gvSIG shp driver"),new File("c:/Layers/puntosPrueba.shp"),CRSFactory.getCRS("EPSG:23030"));
		} catch (DriverException e) {
			e.printStackTrace();
		} catch (DriverLoadException e) {
			e.printStackTrace();
		}

	}
}
