/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.fmap.tools.Events;

import java.awt.event.MouseEvent;
import java.awt.geom.Rectangle2D;


/**
 * Eventos de rectngulo sobre la vista.
 *
 * @author Vicente Caballero Navarro
 */
public class RectangleEvent {
    private Rectangle2D rect;
    private Rectangle2D pixRect;
    private MouseEvent event;

	/**
	 * Crea un nuevo RectangleEvent.
	 * @param worldRect Rectngulo.
	 * @param pixelRect TODO
	 */
    public RectangleEvent(Rectangle2D worldRect, MouseEvent e, Rectangle2D pixelRect) {
        rect = worldRect;
        event = e;
        pixRect = pixelRect;
    }

	/**
	 * Devuelve el rectngulo en coordenadas de mundo real.
	 *
	 * @return Rectngulo.
	 */
    public Rectangle2D getWorldCoordRect() {
        return rect;
    }
    
    /**
     * Devolvemos el rectngulo en pixels para que se puedan
     * comprobar cosas como que es menor de 3 pixels de ancho o alto
     * y hacer un zoom fijo en lugar de a ese rectngulo tan pequeo.
     * 
     * @return
     */
    public Rectangle2D getPixelCoordRect() {
        return pixRect;
    }
    

	public MouseEvent getEvent() {
		return event;
	}
}
